      program potts_rw ! Bernd Berg Dec 11 2006. Compile: ../make77.
C Potts models: Energy histogram from re-weighting of random sampling.
C               Error calculation from bins as stored.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'potts.par'
      include 'mc.par'
c     parameter(beta0=beta,Cfactor=ms*(beta0*2*nd)**2)
      parameter(beta0=four/ten,Cfactor=ms*(beta0*2*nd)**2)
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension hasum(0:mlink),hae(0:mlink),hb(0:mlink),hbe(0:mlink),
     & actl(0:nrpt),C(0:nrpt),Ca(nrpt)
      data hasum/(mlink+1)*zero/,hae/(mlink+1)*zero/,hbe/(mlink+1)*zero/
      include 'lat.dat'
      ltest=.true.
      ltest=.false.
      if(ltest) stop "potts_rw: ltest."
C
      write(cd,'(I1.1)') nd ! Prepare to read the data.
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      write(iuo,'(/,"potts_rw: reweight to beta0 =",F12.8)') beta0
      if(ltest) write(iuo,'(/,2X,"irpt",4X,"actl",7X,"ha(mlink)",/)') 
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="old")
      read(iud1) beta_in,nd_in,nq_in,nla,nlink,nequi_in,nrpt_in,nmeas_in
      if(nrpt.ne.nrpt_in) stop "nrpt.ne.nrpt_in."
      if(nmeas.ne.nmeas_in) stop "nmeas.ne.nmeas_in."
      do irpt=1,nrpt
        read(iud1) ha,acpt,irpt_in
        do ilink=0,mlink
          hasum(ilink)=hasum(ilink)+ha(ilink)
        enddo
        call potts_rwght(mlink,ha,hae,beta,beta0,hb,hbe)
        actl(irpt)=potts_actl(mlink,hb)
        act2l=potts_act2l(mlink,hb)
        C(irpt)=Cfactor*(act2l-actl(irpt)**2) ! From bins.
        Ca(irpt)=Cfactor*potts_mu2(mlink,hb,actl(irpt))
        if(ltest) write(iuo,'(I6,2G14.5)') irpt,actl(irpt),ha(mlink)
      enddo
      call steb0(nrpt,actl(1),actlm,av,actlme)
      write(iuo,'(/,1X,"Average over reweighted bins:",/)') 
      write(iuo,'(" Energy (action per link variable):",/)') 
      write(iuo,'(3X,"actlm =",F10.6,2X,"+/-",F10.6)') actlm,actlme
      call potts_rwght(mlink,hasum,hae,beta,beta0,hb,hbe)
      actl(0)=potts_actl(mlink,hb)
      write(iuo,'(3X,"actlm =",F10.6,2X,"from all data")') actl(0)
      write(iuo,'(/,1X,"Specific heat:")') 
      call steb0(nrpt,C(1),Cm,Cv,Cme)
      write(iuo,'(/,3X,"From actl**2(i)-mean(i)**2:")') 
      write(iuo,'(3X,"Cm =  ",F10.6,2X,"+/-",F10.6,2X,
     &               "from binning")') Cm,Cme
      call steb0(nrpt,Ca(1),Cm,Cv,Cme)
      write(iuo,'(/,3X,"From (actl-mean(i))**2:")') 
      write(iuo,'(3X,"Cm =  ",F10.6,2X,"+/-",F10.6,2X,
     &               "from binning")') Cm,Cme
C
      act2lm=potts_act2l(mlink,hb)
      C(0)=Cfactor*(act2lm-actl(0)**2) ! From entire statistics.
      write(iuo,'(3X,"Cm =  ",F10.6,"  from entire statistics")') C(0)
      rewind iud1
      read(iud1) nrpt_in,nmeas_in
      do irpt=1,nrpt
        read(iud1) ha,acpt,irpt_in
        call potts_rwght(mlink,ha,hae,beta,beta0,hb,hbe)
        act2l=potts_act2l(mlink,hb)
        C(irpt)=Cfactor*(act2l-actl(0)**2) ! From bins.
        Ca(irpt)=Cfactor*potts_mu2(mlink,hb,actl(0))
      enddo
      close(iud1)
      write(iuo,'(/," Using mean from entire statistics:")')
      call steb0(nrpt,C(1),Cm,Cv,Cme)
      write(iuo,'(/,3X,"From actl**2-mean**2:")') 
      write(iuo,'(3X,"Cm =  ",F10.6,2X,"+/-",F10.6)') Cm,Cme
      call steb0(nrpt,Ca(1),Cm,Cv,Cme)
      write(iuo,'(/,3X,"From (actl-mean)**2:")') 
      write(iuo,'(3X,"Cm =  ",F10.6,2X,"+/-",F10.6)') Cm,Cme
      write(iuo,'(/," potts_rw: all done.",/)')
      stop
      end


      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/potts_act2l.f'
      include '../../Libs/Fortran/potts_mu2.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_rwght.f'
      include '../../Libs/Fortran/steb0.f'
