      program prod_bias ! Bernd Berg Dec 9 2006. Compile with ../make77.
C Potts models: Energy histogram from naive sampling.
      include '../../Libs/Fortran/implicit.sta'
      character cd*1,cq*2,cl*3
      include '../../Libs/Fortran/constants.par'
      include 'lat.par'
      include 'potts.par'
      include 'mc.par'
      parameter(njob=10 000,beta0=four/ten,Cfactor=ms*(beta0*2*nd)**2)
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension hasum(0:mlink),hae(0:mlink),hb(0:mlink),hbe(0:mlink),
     & haj(0:mlink),hbj(0:mlink),Ca(nrpt),Cj(nrpt),Cam(njob),Came(njob),
     & Cjm(njob),Cmm(njob),Cjme(njob), ix(nd)
      include 'lat.dat'
      data hae/(mlink+1)*zero/, hbe/(mlink+1)*zero/
      ltest=.true.
      ltest=.false.
      if(ltest) stop "prod_bias: ltest."
C
      write(iuo,'(/,"prod_bias sampling:")') 
      write(iuo,'(" nd,nq,nrpt,nmeas =",3I6,I12)') nd,nq,nrpt,nmeas
      write(cd,'(I1.1)') nd
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      call rmaset(iuo,iud1,iseed1,iseed2,'ranmar.d')
      call lat_init(ms,nd,ipf,ipb,nla,ix)
      call potts_act_tab(idel,nqm1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="unknown")
      do ijob=1,njob
        rewind iud1
        write(iud1) beta,nd,nq,nla,mlink,nequi,nrpt,nmeas,iseed1,iseed2
        do irpt=1,nrpt
          call razero(ha,izero,mlink)
          do idat=1,nmeas
            call potts_ran(ista,ms,nq)
            call potts_act(ista,ipf,idel,ms,nqm1,nd,iact)
            ha(iact)=ha(iact)+one
          end do
c         write(iuo,'(" irpt,iact,ha:",2I12,G14.5)') irpt,iact,ha(mlink)
          write(iud1) ha,one,irpt
        end do
        call write_progress(iud2,"ijob,iact,ha:",ijob,iact,ha(mlink))
C
C On the fly analysis of the data (they will be overwrittten afterwards):
        rewind iud1
        read(iud1) 
        call razero(hasum,izero,mlink)
        do irpt=1,nrpt
          read(iud1) ha,acpt,irpt_in
          do ilink=0,mlink
            hasum(ilink)=hasum(ilink)+ha(ilink)
          end do
        end do
        call potts_rwght(mlink,hasum,hae,beta,beta0,hb,hbe)
        actlm=potts_actl(mlink,hb)
        act2lm=potts_act2l(mlink,hb) 
        Cm=Cfactor*(act2lm-actlm**2) ! From entire statistics.
        rewind iud1
        read(iud1) 
        do irpt=1,nrpt
          read(iud1) ha,acpt,irpt_in
          do ilink=0,mlink
            haj(ilink)=hasum(ilink)-ha(ilink)
          end do
          call potts_rwght(mlink,ha,hae,beta,beta0,hb,hbe)  
          Ca(irpt)=Cfactor*potts_mu2(mlink,hb,actlm)
          call potts_rwght(mlink,haj,hae,beta,beta0,hbj,hbe)
          actlj=potts_actl(mlink,hbj)
          act2lj=potts_act2l(mlink,hbj)
          Cj(irpt)=Cfactor*(act2lj-actlj**2) ! Jackknife Cj.
        end do
        call steb0(nrpt,Ca,Cam(ijob),Cv,Came(ijob))
c       print*,"ijob,actlm,Cm,Cme:",ijob,actlm,Cam(ijob),Came(ijob)
        call stebj0(nrpt,Cj,Cjm(ijob),Cv,Cjme(ijob))
        call bias(nrpt,Cj,Cm,Cmm(ijob),Cbias)
c       print*,"     Cjm,Cmm,Cjme:",Cjm(ijob),Cmm(ijob),Cjme(ijob),Cbias
      enddo
      close(iud1)
C Save results:
      open(iud1,file="prod_bias.D",form="unformatted",status="unknown")
      write(iud1) Cam,Came,Cjm,Cmm,Cjme
      close(iud1)
C
      write(iuo,'("prod_bias: All done.")') 
      stop
      end


      include '../../Libs/Fortran/bias.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/potts_act2l.f'
      include '../../Libs/Fortran/potts_mu2.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_rwght.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/steb0.f'
      include '../../Libs/Fortran/stebj0.f'
      include '../../Libs/Fortran/stmean.f'
      include '../../Libs/Fortran/write_progress.f'
