      SUBROUTINE READ_STEB0(nrpt,iud,norm,nlink,ha,ham,hae,actl)
C Bernd Berg Jan 21 2002.
C Reads nrpt times the array ha() from unit iud and calculates the
C       histogram mean values ham() and their error bars hae().
C Further, the nrpt action variable averages are calculated.
C norm=0:  no normalization of the ha histogram, otherwise normalization.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      dimension ha(0:nlink),ham(0:nlink),hae(0:nlink),actl(nrpt)
C
      call razero(ham,izero,nlink)
      factor=one
      do irpt=1,nrpt
        read(iud) ha
	if(norm.ne.0) then ! Normalization of ha() to hasum=nlink.
          hasum=zero
          do ilink=0,nlink
            hasum=hasum+ha(ilink)
          end do
          factor=nlink/hasum
          do ilink=0,nlink ! Normalization of ha() to hasum=nlink.
            ha(ilink)=factor*ha(ilink)
          end do
        end if
        actl(irpt)=potts_actl(nlink,ha) ! Mean action variable.
        do ilink=0,nlink
          ham(ilink)=ham(ilink)+ha(ilink)
        end do
      end do
      do ilink=0,nlink
        ham(ilink)=ham(ilink)/nrpt
      end do
C
      do irpt=1,nrpt
        backspace iud
      end do
C
      call razero(hae,izero,nlink)
      do irpt=1,nrpt
        read(iud) ha
        do ilink=0,nlink
          hae(ilink)=hae(ilink)+(factor*ha(ilink)-ham(ilink))**2
        end do
      end do
      do ilink=0,nlink
        hae(ilink)=sqrt(hae(ilink)/(nrpt*(nrpt-1)))
      end do
C
      return
      end
