      program pierrorbar ! Bernd Berg Sep 08 2008.
c pi estimate with bootstrp and heapsort.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      parameter(iuo=6,iud=10,miuo=-iuo,iseed1=1,iseed2=1)
      parameter(ndat=10**3,nrpt=1001)
      dimension api(nrpt)
c
      write(iuo,'(/," ndat,nprt, pi analytical =",2I9,1F10.5,/)') 
     &                ndat,nrpt,pi
      call rmaset(miuo,iud,iseed1,iseed2,'ranmar.d')
      do irpt=1,nrpt
        events=zero
        do idat=1,ndat
          call ranmar(xr)
          call ranmar(yr)
	  if(xr**2+yr**2.lt.one) events=events+one
        end do
        api(irpt)=4*events/ndat
        call write_progress(iud,"irpt,nrpt,api:",irpt,nrpt,api(irpt))
      enddo
c
      call steb0(nrpt,api,pim,piv,pie)
      pi025=pim-2*pie
      pi15=pim-pie
      pi85=pim+pie
      pi975=pim+2*pie
      write(iuo,'(" pi =",F10.6,2X,"+/-",F10.6,/)') pim,pie
      write(iuo,'(" 95% and 70% confidence ranges from error bars:",/)')
      write(iuo,'(6X,"0.025%",7X,"15%",8X,"Mean",9X,"85%",8X,"97.5%",/
     &  ,/,5F12.7)') pi025,pi15,pim,pi85,pi975
c
      stop
      end

      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/steb0.f'
      include '../../Libs/Fortran/write_progress.f'
